#pragma comment(lib,"OpenGL32.lib")
#pragma comment(lib,"glu32.lib")
#pragma comment(lib,"SDL.lib")
#pragma comment(lib,"SDL_image.lib")
#pragma comment(lib,"SDLmain.lib")
#pragma comment(lib,"fmodvc.lib")

#include "video.h"
#include "game.h"
#include "burglar.h"

#include "fmod.h"

int fs = 0;

Model *ninja, *cop, *grail;
int done;
Font *f32,*f24,*f16;

FMUSIC_MODULE *music = 0;

int main(int argc, char *argv[])
{
	for (int i=1; i<argc; i++) {
		if (!strcmp(argv[i],"-w")) {
			fs = 0;
		}
		else if (!strcmp(argv[i],"-f")) {
			fs = 1;
		}
	}

	video.init(1024, 768, (fs!=0));
	FSOUND_Init(44100, 32, 0);

	SDL_ShowCursor(0);

	ninja = new Model("data/burglar.model","burglartex.png", 0.5f);
	cop = new Model("data/police.model","policetex.png", 0.5f);
	grail = new Model("data/grail.model", "yellow.png", 0.5f);

	Texture ftex = video.loadTexture("font.png");

	f32 = new Font(ftex, 512, 512, 32, "data/verdana");
	f24 = new Font(ftex, 512, 512, 24, "data/verdana");
	f16 = new Font(ftex, 512, 512, 16, "data/verdana");

	Menu menu;

	done = 0;
	float ftime;
	Uint32 t, last_t, frames = 0, time = 0, fcount = 0, ft = 0;

	t = SDL_GetTicks();
	while (!done) {
		last_t = t;
		t = SDL_GetTicks();
		Uint32 dt = t - last_t;
		time += dt;
		ftime = time / 1000.0f;
		float fdt = dt / 1000.0f;


		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

		menu.update(fdt);

		menu.draw();



		SDL_GL_SwapBuffers();

		frames++;
		fcount++;
		ft += dt;
		if (ft >= 1000) {
            float fps = (float)fcount / (float)ft * 1000.0f;
			char buf[32];
			sprintf(buf,"Burglar - %.2f fps",fps);
			SDL_WM_SetCaption(buf,NULL);
            ft = 0;
			fcount = 0;
		}
	}

    video.close();

	return 0;
}

void classifyPoint(Vec2D p, Vec2D a, Vec2D b, float &dist, float &sign, float &closest) {
	
	Vec2D d = b-a;
	float u = (p-a)*d / d.lengthSquared();
	Vec2D q = a + u*d;

	dist = (q-p).length();
	sign = - ( a.x * (b.y - p.y) + a.y * (p.x - b.x) + p.y * b.x - p.x * b.y );
	closest = u;
}

void playMusic(const char *filename)
{
	FMUSIC_StopAllSongs();
	if (music != 0) FMUSIC_FreeSong(music);
	music = FMUSIC_LoadSong(filename);
	FMUSIC_PlaySong(music);
}

void shutup()
{
	FMUSIC_StopAllSongs();
}

