#ifndef VIDEO_H
#define VIDEO_H

#include "SDL/SDL.h"
#include "SDL/SDL_opengl.h"
#include "SDL/SDL_image.h"

#include <map>
#include <string>

typedef GLuint Texture;


struct Video {
	int xres,yres;

	void init(int xres, int yres, bool fs);
	void close();

	Texture loadTexture(std::string filename);
	void unloadTexture(Texture tex);

	SDL_Surface *primary;

	std::map<std::string, Texture> textureCache;

	void set2D();
	void set3D();

};

extern Video video;



#endif
